#!BPY
""" 
Name: 'Export CFF'
Blender: 2.48
Group: 'Export'
Tooltip: 'Export CFF Files'
"""
__author__ = "Jor1980"
__url__ = ("", "")
__version__ = "1.0"
__bpydoc__ = ""


# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****




import Blender, BPyMesh
from Blender import *
from Blender import Window
from Blender import sys as bsys
REG_KEY = 'cff_reg'
EXPORT_DIR = ''
IMPORT_DIR = ''
idxcero = 0
tooltips = {
	'EXPORT_DIR': "default / last folder used to export .cff files to",
	'IMPORT_DIR': "default / last folder used to import .cff files from"
}

def update_RegistryInfo():
	d = {}
	d['EXPORT_DIR'] = EXPORT_DIR
	d['IMPORT_DIR'] = IMPORT_DIR
	Blender.Registry.SetKey(REG_KEY, d, True)
rd = Blender.Registry.GetKey(REG_KEY, True)

if rd:
	try:
		EXPORT_DIR = rd['EXPORT_DIR']
		IMPORT_DIR = rd['IMPORT_DIR']
	except KeyError: update_RegistryInfo()

else:
	update_RegistryInfo()
	
	

global import_dir,tipo

editmode = Blender.Window.EditMode()    # Si estamos en editmode lo quita para que los cambios en la malla tengan efecto
if editmode: Blender.Window.EditMode(0)

escena=Scene.GetCurrent()




		
		


	
fname = ".cff"


# File Selector callback:
def fs_callback(filename):
	global EXPORT_DIR

	if not filename.endswith('.cff'): filename = '%s.cff' % filename

	if bsys.exists(filename):
		if Blender.Draw.PupMenu('OVERWRITE?%t|File exists') != 1:
			return

	editmode = Blender.Window.EditMode()    # are we in edit mode?  If so ...
	if editmode: Blender.Window.EditMode(0) # leave edit mode before getting the mesh

	starttime = bsys.time()

	export_dir = bsys.dirname(filename)
	if export_dir != EXPORT_DIR:
		EXPORT_DIR = export_dir
		update_RegistryInfo()
		
	archivosalida=open(filename,"w")
	archivosalida.write("//Ciber Face Converter File (c)2009 by Jor1980")
	archivosalida.write(chr(10))
	archivosalida.write(chr(10))
	nombreescena=escena.name.split(chr(10))[0]		
	archivosalida.write("Type=" + nombreescena)
	archivosalida.write(chr(10))
	archivosalida.write("Number of blocks=")
	archivosalida.write(str(len(escena.objects)))
	archivosalida.write(chr(10))
	archivosalida.write("Number of vertex and faces per block=")
	archivosalida.write(chr(10))


	for i in range(0,len(escena.objects)):
		objeto=escena.objects[len(escena.objects)-i-1]
		datosobjeto=objeto.getData()
		archivosalida.write(str(len(datosobjeto.verts)) + ' ' + str(len(datosobjeto.faces)))
		archivosalida.write(chr(10))
			
			
	for i in range(0,len(escena.objects)):
		objeto=escena.objects[len(escena.objects)-i-1]
		datosobjeto=objeto.getData()
		print objeto.name
	
		x=[]
		y=[]
		z=[]
		for v in datosobjeto.verts:
			
			x.append(v.co[0])
			y.append(v.co[1])
			z.append(v.co[2])
		
		listadeindices=[]
		listauv=[]
		
		for f in datosobjeto.faces:
			for j in range(0,3):
				listadeindices.append(f.v[j].index)
				listauv.append(f.uv[j])	
				
		for f in range(1,len(listadeindices)):			#Ordena los indices y su coordenadas uv
			for j in range(0, len(listadeindices)-f):
				if listadeindices[j] > listadeindices[j+1]:
					
					Blender.Window.WaitCursor(1)
					elemento = listadeindices[j]
					elementouv=listauv[j]
					listadeindices[j] = listadeindices[j+1]
					listauv[j]=listauv[j+1]
					listadeindices[j+1] = elemento
					listauv[j+1]=elementouv
	
		elementos=1	
				
		while elementos< (len(listadeindices)-1):    #Borra los indices repetidos y sus coordenadas uv
			
			
			
			while ((elementos) < (len(listadeindices)-2) and listadeindices[elementos]==listadeindices[elementos +1]):
				
				Blender.Window.WaitCursor(1)	
				del listadeindices[elementos+1]
				del listauv[elementos+1]
				
		
			elementos+=1
				
	
		
		if listadeindices[0]==listadeindices[1]:
			del listadeindices[1]
			del listauv[1]
			
		while listadeindices[len(listadeindices)-2] == listadeindices[len(listadeindices)-1]:
			del listadeindices[len(listadeindices)-1]
			del listauv[len(listadeindices)-1]
			print listadeindices[len(listadeindices)-1]
		
		print "Numero de vertices", len(listadeindices)	
		print(listadeindices)
		
		contador=0
		
		
		
		
					
 		for v in datosobjeto.verts:
			
			Blender.Window.WaitCursor(1)
			print "Len verts",len(datosobjeto.verts)
			if contador < len(datosobjeto.verts)-1:
				print contador
				uv=listauv[contador]
				u=uv[0]
				v=uv[1]
			else:
				uv=listauv[len(listauv)-1]
				u=uv[0]
				v=uv[1]	
			
			archivosalida.write("%8f %8f %8f %8f %8f" % (x[contador],y[contador],z[contador],u,v))
			archivosalida.write(chr(10))
			contador=contador+1
		
		for f in datosobjeto.faces:
			
			Blender.Window.WaitCursor(1)
			a=str(f.v[0].index)		
			b=str(f.v[1].index)
			c=str(f.v[2].index)
			indices=a +' ' + b + ' ' + c
			archivosalida.write(indices)
			archivosalida.write(chr(10))
			
		
		
	archivosalida.close	
			
tp = Scene.GetCurrent()		
objs = tp.getChildren()
if not objs:
	Blender.Draw.PupMenu('ERROR: no objects in scene')
else:
	fname = ".cff"
	if EXPORT_DIR:
		fname = bsys.join(EXPORT_DIR, bsys.basename(fname))
	Window.FileSelector(fs_callback, "Export CFF", fname)








	

	
	
	