#!BPY

"""
Name: 'Import CFF'
Blender: 2.48
Group: 'Import'
Tip: 'Import CFF Files'
"""

__author__ = "Jor1980"
__url__ = ("", "")
__version__ = "1.0"
__bpydoc__ = ""


# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****








import Blender
from Blender import Window
from Blender import sys as bsys
from Blender import *
import bpy
REG_KEY = 'cff_reg'
EXPORT_DIR = ''
IMPORT_DIR = ''


def update_RegistryInfo():
	d = {}
	d['EXPORT_DIR'] = EXPORT_DIR
	d['IMPORT_DIR'] = IMPORT_DIR
	Blender.Registry.SetKey(REG_KEY, d, True)
rd = Blender.Registry.GetKey(REG_KEY, True)

if rd:
	try:
		EXPORT_DIR = rd['EXPORT_DIR']
		IMPORT_DIR = rd['IMPORT_DIR']
	except KeyError: update_RegistryInfo()

else:
	update_RegistryInfo()
	
	

global import_dir,tipo
	



def load_data(file):
	global import_dir,tipo
	file.next()
	CffType=file.next().replace('Type=','')
	Scene_Name=CffType
	sc=Scene.New(Scene_Name)
	sc.makeCurrent()
	#sc = Scene.GetCurrent()
	screen_list = Window.GetScreens()
	for screens in screen_list:
		Window.SetScreen(screens)
		sc.makeCurrent()
	Window.SetScreen(screen_list[0])
	numeroparts=int(file.next().replace('Number of blocks=',''))
	print numeroparts
	numerovertxpart=[]
	numerofacexpart=[]
	file.next()
	
	
	
	for i in range(0,numeroparts):
		line=file.next()
		print line.split()[0]
		print line.split()[1]
		numerovertxpart.append(int(line.split()[0]))
		print numerovertxpart[i]
		numerofacexpart.append(int(line.split()[1]))
		print numerofacexpart[i] 	
	
	
	
	
	
	

	
	malla=[]
	ob=[]
	for i in range(0,numeroparts):
		malla.append(bpy.data.meshes.new("2K_Part"))
		uv = []
	
		for j in range(0,numerovertxpart[i]):
			line=file.next()
			x,y,z,u,v=float(line.split()[0].replace(',','.')),float(line.split()[1].replace(',','.')),float(line.split()[2].replace(',','.')),float(line.split()[3].replace(',','.')),float(line.split()[4].replace(',','.'))
			uv.append((u,v))
			print x,y,z
			malla[i].verts.extend(float(x),float(y),float(z))
		
		aa = []
		bb = []
		cc = []
	
		
		for j in range(0,numerofacexpart[i]):
			line=file.next()
			a,b,c=int(line.split()[0]),int(line.split()[1]),int(line.split()[2])
			aa.append(a)
			bb.append(b)
			cc.append(c)
			print a,b,c
			bface = Blender.NMesh.Face()
			bface.v.extend((a,b,c))
			malla[i].faces.extend(bface)
			
		malla[i].faceUV = True
	
	
		for q in range(len(malla[i].faces)):
			malla[i].faces[q].mode |= Blender.Mesh.FaceModes['TWOSIDE']
			malla[i].faces[q].transp = Blender.NMesh.FaceTranspModes['ALPHA']
			malla[i].faces[q].uv=Mathutils.Vector(uv[aa[q]]), Mathutils.Vector(uv[bb[q]]), Mathutils.Vector(uv[cc[q]])
	
		
		
		scn = bpy.data.scenes.active
		ob.append(scn.objects.new(malla[i], CffType))
		ob[i].modifiers.append(Modifier.Types.SUBSURF)
		ob[i].modifiers.append(Modifier.Types.SUBSURF)
		
	
	
	







	











def fs_callback(filename):
	global IMPORT_DIR, EXPORT_DIR, import_dir, weather
	weather = ''
	
	if not filename.endswith('.cff'): filename = '%s.cff' % filename
	Blender.Window.WaitCursor(1)
	starttime = bsys.time()

	import_dir = bsys.dirname(filename)
	
	if import_dir != IMPORT_DIR:
		IMPORT_DIR = import_dir
		update_RegistryInfo()
			
	file = open(filename,"r")
	header = file.readline()
	if header != '//Ciber Face Converter File (c)2009 by Jor1980\n':
		Blender.Draw.PupMenu('This is not a *.cff file')
		print header
		file.close()
		return

	if not load_data(file):
		Blender.Draw.PupMenu('Move the cursor please')
		file.close()
		return
		
	file.close()
	endtime = bsys.time() - starttime
	print "Data imported in %.3f seconds." % endtime

	Blender.Window.WaitCursor(0)
	return 

objs = Blender.Object.Get()

fname = "*.cff"
if IMPORT_DIR:
	fname = bsys.join(IMPORT_DIR, bsys.basename(fname))
			
	
Window.FileSelector(fs_callback,"Import *.cff",fname)	
	